﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class mcyinder : MonoBehaviour {
    int objno = 2; // set this to the RTcmix instance you are using for this script
    rtcmixmain RTcmix;
    private bool did_start = false;

    String score;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        score = "ldamp = 10000 " +
            "ldampenv = maketable(\"line\", 1000, 0,0, 1,1, 2,0) " +
            "ldwave = maketable(\"wave\", 1000, \"saw\") " +
            "lddur = 5 " +
            "ldfreq = 100 " +
            "for (i = 0; i < 4; i = i+1) { " +
            "   WAVETABLE(0, lddur, ldamp*ldampenv, ldfreq+irand(-10, 10), 0.5, ldwave) " +
            "} " +
            "MAXBANG(lddur/2) ";

        RTcmix.SendScore(score, objno);

        did_start = true;
    }


    // Update is called once per frame
    void Update()
    {
    }


    // called once for each sample-buffer. data[] contains incoming and outgoing samples
    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0); // set "0" to "1" for input processing

        if (RTcmix.checkbangRTcmix(objno) == 1)
        {
            // a MAXBANG was received
            RTcmix.SendScore(score, objno);
        }
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
