﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class mcylfilt : MonoBehaviour {
    int objno = 3; // set this to the RTcmix instance you are using for this script
    rtcmixmain RTcmix;
    private bool did_start = false;

    String score;

    GameObject obs;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
        obs = GameObject.Find("observer");
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        score = "rtinput(\"AUDIO\") " +
            "ffreq = makeconnection(\"inlet\", 1, 1000) " +
            "MOOGVCF(0, 0, 9999, 2, 0, 0.5, 0, ffreq, 0.3) ";

        RTcmix.SendScore(score, objno);

        did_start = true;
    }


    // Update is called once per frame
    void Update()
    {
        float ffreq;

        float distance = Vector3.Distance(obs.transform.position, transform.position);

        float mapval = distance / 25.0f;

        ffreq = Mathf.Lerp(2000.0f, 200.0f, mapval);


        RTcmix.setpfieldRTcmix(1, ffreq, objno);
    }


    // called once for each sample-buffer. data[] contains incoming and outgoing samples
    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 1); // set "0" to "1" for input processing

    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
