﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class spraytrigger : MonoBehaviour
{
    int objno = 1; // set this to the RTcmix instance you are using for this script
    rtcmixmain RTcmix;
    private bool did_start = false;

    String score;

    ParticleSystem sprayps;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
        sprayps = GameObject.Find("sprayparticles").GetComponent<ParticleSystem>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        score = "stamp = 20000 " +
            "stampenv = maketable(\"line\", 1000, 0,0, 1,1, 2,0) " +
            "stwave = maketable(\"wave\", 1000, \"square\") " +
            "stpch = 5.00 " +
            "stdur = 0.1 " +
            "st = 0 " +
            "for (i = 0; i < 20; i += 1) { " +
            "   stpch= stpch + 0.05 " +
            "   WAVETABLE(st, stdur, stamp*stampenv, stpch, 0.5, stwave) " +
            "   st = st + (stdur/2) " +
            "   stamp = stamp-1000 " +
            "} ";

        did_start = true;
    }

    // Update is called once per frame
    void Update () {
		
	}

    private void OnTriggerEnter(Collider other)
    {
        RTcmix.SendScore(score, objno);
        sprayps.Play();
    }

    // called once for each sample-buffer. data[] contains incoming and outgoing samples
    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0); // set "0" to "1" for input processing
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
